
mir='m';
cm=0.01;
Amax=30;


mu=10^-4;
mii=mir;
ct='r';

VFvals=(-1:.25:1);
VMvals=(-1:.25:1);
dataname=strcat('td_',mir,'_',num2str(cm),'_',num2str(size(VFvals,2)),'x',num2str(size(VMvals,2)),'.mat');
isitTname=strcat('td_isitT_',mir,'_',num2str(cm),'_',num2str(size(VFvals,2)),'x',num2str(size(VMvals,2)),'.mat');
Tdenname=strcat('td_Tden_',mir,'_',num2str(cm),'_',num2str(size(VFvals,2)),'x',num2str(size(VMvals,2)),'.mat');
does_it_climbname=strcat('td_does_it_climb_',mir,'_',num2str(cm),'_',num2str(size(VFvals,2)),'x',num2str(size(VMvals,2)),'.mat');

%rows will correspond to values of A, and columns will correspond to values of a.
td_mat=zeros(size(VFvals,2),size(VMvals,2));
isitT_mat=-1*ones(size(VFvals,2),size(VMvals,2));
Tden_mat=-1*ones(size(VFvals,2),size(VMvals,2));
does_it_climb_mat=zeros(size(VFvals,2),size(VMvals,2));


for k=1:size(VFvals,2);
    for j=1:size(VMvals,2);
        
        vf=VFvals(k);
        vm=VMvals(j);
        
        [frm,mrm]=find_msb(mir,1,ct,cm,vf,vm,mu);
        
        %dropping section
        numsteps=25;
        ends=flipdim(exp(0:log(Amax)/(numsteps-1):log(Amax)),2);
        
        dropping=1;
        stopup=0;
        while dropping==1
            stopup=stopup+1;
            dropping=comp_td(mir,ends(stopup),mii,ends(stopup+1),ct,cm,vf,vm,mu);
            if stopup+1==numsteps && dropping==1
                dropping=2;
            end
        end
        
        if dropping==2
            buESS=0;
        else
            if stopup==1
                buESS=log(Amax);
            else
                
                %homing section
                boundaries=[log(ends(stopup-1)),log(ends(stopup+1))];
                while boundaries(1)-boundaries(2)>0.01
                    dropping=comp_td(mir,exp(mean(boundaries)),mii,exp(mean(boundaries)-.0001),ct,cm,vf,vm,mu);
                    if dropping==1
                        boundaries(1)=mean(boundaries);
                    else
                        boundaries(2)=mean(boundaries);
                    end
                end
                buESS=mean(boundaries);
                
            end
        end

        fstart=[0;0;0;0;1;0;0;0];
        mstart=[0;0;1;0];
        [fESS,mESS]=find_msb2(mir,exp(buESS),ct,cm,vf,vm,mu,fstart,mstart);
        
        %finally, once it is down there, can it go back up?
        %first, check to see if the stopping point can still be invaded
        %downward
        dropping=comp_td(mir,exp(buESS),mii,exp(buESS-.01),ct,cm,vf,vm,mu);
        if dropping==1
            
            %if it can, then get the starting msb for climbing
            fstart=[0;0;0;0;1;0;0;0];
            mstart=[0;0;1;0];
            [fstart,mstart]=find_msb2(mir,exp(buESS-.01),ct,cm,vf,vm,mu,fstart,mstart);
            
            %now, let it climb
            [climbing,f,m]=comp_td_fm(mir,exp(buESS),mii,exp(buESS+.01),ct,cm,vf,vm,mu,fstart,mstart);
            stopup=0;
            if climbing==1
                does_it_climb_mat(k,j)=1;
            end
            while climbing==1 && buESS<log(Amax)
                
                %climbing section
                ends=exp(buESS:(log(Amax)-buESS)/(numsteps-1):log(Amax));
                stopup=stopup+1;
                [climbing,fstart,mstart]=comp_td_fm(mir,ends(stopup),mii,ends(stopup+1),ct,cm,vf,vm,mu,fstart,mstart);
                if stopup+1==numsteps && climbing==1
                    climbing=2;
                end
                
            end
            
            if climbing==2
                buESS=log(Amax);
            end
            
            if ends(1)<ends(2)
                
                %homing section
                boundaries=[log(ends(stopup-1)),log(ends(stopup+1))];
                while boundaries(2)-boundaries(1)>0.01
                    climbing=comp_bu(mir,exp(mean(boundaries)),mii,exp(mean(boundaries)+.0001),ct,cm,vf,vm,mu);
                    if climbing==1
                        boundaries(1)=mean(boundaries);
                    else
                        boundaries(2)=mean(boundaries);
                    end
                end
                buESS=mean(boundaries);
                
                [fESS,mESS]=find_msb2(mir,exp(buESS),ct,cm,vf,vm,mu,fstart,mstart);
                
            end
        end
          
        td_mat(k,j)=buESS;
        on_step=[k,j,td_mat(k,j)]
        save(dataname,'td_mat')
        save(does_it_climbname,'does_it_climb_mat')
        
        Tden_mat(k,j)=mESS(3);
        save(Tdenname,'Tden_mat')
        
        if mESS(3)>mrm(3)
            isitT_mat(k,j)=1;
            save(isitTname,'isitT_mat')
        end
        
    end
end

